/*
 * arch/arm/mm/mm-vnc.c
 *
 * support for NetWinder architecture
 *
 * Copyright <C> 1998 Corel Computer Corp
 *
 */
#include <linux/mm.h>
#include <asm/arch/hardware.h>
#include <asm/pgtable.h>

/* page tables for IO space on the VNC
 * just go ahead and copy these into the page tables for 0xE0000000
 */
// NOTE: if you add entries, go to mm-init.h and change NR_IO_ENTRIES
unsigned long vnc_io_page_table[] = {
        // logical addr == IO_BASE == 0xE0000000
        DC21285_PCI_IO | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        // logical addr == 0xE0100000
        DC21285_PCI_TYPE_0_CONFIG | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 2 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 3 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 4 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 5 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 6 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 7 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 8 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 9 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 10 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 11 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 12 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 13 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_PCI_TYPE_0_CONFIG + 14 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        
        // logical addr == 0xE1000000
        DC21285_ARMCSR_BASE          | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_PCI_IACK             | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_SA_CACHE_FLUSH       | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_OUTBOUND_WRITE_FLUSH | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,

        // logical addr == 0xE1400000
        DC21285_ETH100_MEM           | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        /* patb: Oct 27/98 access to 0x4000000: dram and Xbus */
        DC21285_DRAM_A0MR            | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_OUTBOUND_WRITE_FLUSH | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_OUTBOUND_WRITE_FLUSH | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        DC21285_FLASH                | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 2 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 3 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 4 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 5 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 6 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE,
        (DC21285_FLASH + 7 * PGDIR_SIZE) | PMD_TYPE_SECT | PMD_DOMAIN(DOMAIN_KERNEL) | PMD_SECT_AP_WRITE
};

